# streambuf

Go to the documentation of this file.

    00001 // Stream buffer classes -*- C++ -*-
    00002
    00003 // Copyright (C) 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006
    00004 // Free Software Foundation, Inc.
    00005 //
    00006 // This file is part of the GNU ISO C++ Library.  This library is free
    00007 // software; you can redistribute it and/or modify it under the
    00008 // terms of the GNU General Public License as published by the
    00009 // Free Software Foundation; either version 2, or (at your option)
    00010 // any later version.
    00011
    00012 // This library is distributed in the hope that it will be useful,
    00013 // but WITHOUT ANY WARRANTY; without even the implied warranty of
    00014 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    00015 // GNU General Public License for more details.
    00016
    00017 // You should have received a copy of the GNU General Public License along
    00018 // with this library; see the file COPYING.  If not, write to the Free
    00019 // Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
    00020 // USA.
    00021
    00022 // As a special exception, you may use this file as part of a free software
    00023 // library without restriction.  Specifically, if other files instantiate
    00024 // templates or use macros or inline functions from this file, or you compile
    00025 // this file and link it with other files to produce an executable, this
    00026 // file does not by itself cause the resulting executable to be covered by
    00027 // the GNU General Public License.  This exception does not however
    00028 // invalidate any other reasons why the executable file might be covered by
    00029 // the GNU General Public License.
    00030
    00031 /** @file streambuf
    00032  *  This is a Standard C++ Library header.
    00033  */
    00034
    00035 //
    00036 // ISO C++ 14882: 27.5  Stream buffers
    00037 //
    00038
    00039 #ifndef _GLIBXX_STREAMBUF
    00040 #define _GLIBXX_STREAMBUF 1
    00041
    00042 #pragma GCC system_header
    00043
    00044 #include <bits/c++config.h>
    00045 #include <iosfwd>
    00046 #include <bits/localefwd.h>
    00047 #include <bits/ios_base.h>
    00048 #include <bits/cpp_type_traits.h>
    00049 #include <ext/type_traits.h>
    00050
    00051 _GLIBCXX_BEGIN_NAMESPACE(std)
    00052
    00053   /**
    00054    *  @if maint
    00055    *  Does stuff.
    00056    *  @endif
    00057   */
    00058   template<typename _CharT, typename _Traits>
    00059     streamsize
    00060     __copy_streambufs_eof(basic_streambuf<_CharT, _Traits>*,
    00061               basic_streambuf<_CharT, _Traits>*, bool&);
    00062
    00063   /**
    00064    *  @brief  The actual work of input and output (interface).
    00065    *
    00066    *  This is a base class.  Derived stream buffers each control a
    00067    *  pair of character sequences:  one for input, and one for output.
    00068    *
    00069    *  Section [27.5.1] of the standard describes the requirements and
    00070    *  behavior of stream buffer classes.  That section (three paragraphs)
    00071    *  is reproduced here, for simplicity and accuracy.
    00072    *
    00073    *  -# Stream buffers can impose various constraints on the sequences
    00074    *     they control.  Some constraints are:
    00075    *     - The controlled input sequence can be not readable.
    00076    *     - The controlled output sequence can be not writable.
    00077    *     - The controlled sequences can be associated with the contents of
    00078    *       other representations for character sequences, such as external
    00079    *       files.
    00080    *     - The controlled sequences can support operations @e directly to or
    00081    *       from associated sequences.
    00082    *     - The controlled sequences can impose limitations on how the
    00083    *       program can read characters from a sequence, write characters to
    00084    *       a sequence, put characters back into an input sequence, or alter
    00085    *       the stream position.
    00086    *     .
    00087    *  -# Each sequence is characterized by three pointers which, if non-null,
    00088    *     all point into the same @c charT array object.  The array object
    00089    *     represents, at any moment, a (sub)sequence of characters from the
    00090    *     sequence.  Operations performed on a sequence alter the values
    00091    *     stored in these pointers, perform reads and writes directly to or
    00092    *     from associated sequences, and alter "the stream position" and
    00093    *     conversion state as needed to maintain this subsequence relationship.
    00094    *     The three pointers are:
    00095    *     - the <em>beginning pointer</em>, or lowest element address in the
    00096    *       array (called @e xbeg here);
    00097    *     - the <em>next pointer</em>, or next element address that is a
    00098    *       current candidate for reading or writing (called @e xnext here);
    00099    *     - the <em>end pointer</em>, or first element address beyond the
    00100    *       end of the array (called @e xend here).
    00101    *     .
    00102    *  -# The following semantic constraints shall always apply for any set
    00103    *     of three pointers for a sequence, using the pointer names given
    00104    *     immediately above:
    00105    *     - If @e xnext is not a null pointer, then @e xbeg and @e xend shall
    00106    *       also be non-null pointers into the same @c charT array, as
    00107    *       described above; otherwise, @e xbeg and @e xend shall also be null.
    00108    *     - If @e xnext is not a null pointer and @e xnext < @e xend for an
    00109    *       output sequence, then a <em>write position</em> is available.
    00110    *       In this case, @e *xnext shall be assignable as the next element
    00111    *       to write (to put, or to store a character value, into the sequence).
    00112    *     - If @e xnext is not a null pointer and @e xbeg < @e xnext for an
    00113    *       input sequence, then a <em>putback position</em> is available.
    00114    *       In this case, @e xnext[-1] shall have a defined value and is the
    00115    *       next (preceding) element to store a character that is put back
    00116    *       into the input sequence.
    00117    *     - If @e xnext is not a null pointer and @e xnext< @e xend for an
    00118    *       input sequence, then a <em>read position</em> is available.
    00119    *       In this case, @e *xnext shall have a defined value and is the
    00120    *       next element to read (to get, or to obtain a character value,
    00121    *       from the sequence).
    00122   */
    00123   template<typename _CharT, typename _Traits>
    00124     class basic_streambuf
    00125     {
    00126     public:
    00127       //@{
    00128       /**
    00129        *  These are standard types.  They permit a standardized way of
    00130        *  referring to names of (or names dependant on) the template
    00131        *  parameters, which are specific to the implementation.
    00132       */
    00133       typedef _CharT                    char_type;
    00134       typedef _Traits                   traits_type;
    00135       typedef typename traits_type::int_type        int_type;
    00136       typedef typename traits_type::pos_type        pos_type;
    00137       typedef typename traits_type::off_type        off_type;
    00138       //@}
    00139
    00140       //@{
    00141       /**
    00142        *  @if maint
    00143        *  This is a non-standard type.
    00144        *  @endif
    00145       */
    00146       typedef basic_streambuf<char_type, traits_type>   __streambuf_type;
    00147       //@}
    00148
    00149       friend class basic_ios<char_type, traits_type>;
    00150       friend class basic_istream<char_type, traits_type>;
    00151       friend class basic_ostream<char_type, traits_type>;
    00152       friend class istreambuf_iterator<char_type, traits_type>;
    00153       friend class ostreambuf_iterator<char_type, traits_type>;
    00154
    00155       friend streamsize
    00156       __copy_streambufs_eof<>(__streambuf_type*, __streambuf_type*, bool&);
    00157
    00158       template<typename _CharT2>
    00159         friend typename __gnu_cxx::__enable_if<__is_char<_CharT2>::__value,
    00160                            _CharT2*>::__type
    00161         __copy_aux(istreambuf_iterator<_CharT2>,
    00162            istreambuf_iterator<_CharT2>, _CharT2*);
    00163
    00164       template<typename _CharT2>
    00165         friend typename __gnu_cxx::__enable_if<__is_char<_CharT2>::__value,
    00166                   istreambuf_iterator<_CharT2> >::__type
    00167         find(istreambuf_iterator<_CharT2>, istreambuf_iterator<_CharT2>,
    00168          const _CharT2&);
    00169
    00170       template<typename _CharT2, typename _Traits2>
    00171         friend basic_istream<_CharT2, _Traits2>&
    00172         operator>>(basic_istream<_CharT2, _Traits2>&, _CharT2*);
    00173
    00174       template<typename _CharT2, typename _Traits2, typename _Alloc>
    00175         friend basic_istream<_CharT2, _Traits2>&
    00176         operator>>(basic_istream<_CharT2, _Traits2>&,
    00177            basic_string<_CharT2, _Traits2, _Alloc>&);
    00178
    00179       template<typename _CharT2, typename _Traits2, typename _Alloc>
    00180         friend basic_istream<_CharT2, _Traits2>&
    00181         getline(basic_istream<_CharT2, _Traits2>&,
    00182         basic_string<_CharT2, _Traits2, _Alloc>&, _CharT2);
    00183
    00184     protected:
    00185       //@{
    00186       /**
    00187        *  @if maint
    00188        *  This is based on _IO_FILE, just reordered to be more consistent,
    00189        *  and is intended to be the most minimal abstraction for an
    00190        *  internal buffer.
    00191        *  -  get == input == read
    00192        *  -  put == output == write
    00193        *  @endif
    00194       */
    00195       char_type*        _M_in_beg;     // Start of get area.
    00196       char_type*        _M_in_cur;     // Current read area.
    00197       char_type*        _M_in_end;     // End of get area.
    00198       char_type*        _M_out_beg;    // Start of put area.
    00199       char_type*        _M_out_cur;    // Current put area.
    00200       char_type*        _M_out_end;    // End of put area.
    00201
    00202       /**
    00203        *  @if maint
    00204        *  Current locale setting.
    00205        *  @endif
    00206       */
    00207       locale            _M_buf_locale;
    00208
    00209   public:
    00210       /// Destructor deallocates no buffer space.
    00211       virtual
    00212       ~basic_streambuf()
    00213       { }
    00214
    00215       // [27.5.2.2.1] locales
    00216       /**
    00217        *  @brief  Entry point for imbue().
    00218        *  @param  loc  The new locale.
    00219        *  @return  The previous locale.
    00220        *
    00221        *  Calls the derived imbue(loc).
    00222       */
    00223       locale
    00224       pubimbue(const locale &__loc)
    00225       {
    00226     locale __tmp(this->getloc());
    00227     this->imbue(__loc);
    00228     _M_buf_locale = __loc;
    00229     return __tmp;
    00230       }
    00231
    00232       /**
    00233        *  @brief  Locale access.
    00234        *  @return  The current locale in effect.
    00235        *
    00236        *  If pubimbue(loc) has been called, then the most recent @c loc
    00237        *  is returned.  Otherwise the global locale in effect at the time
    00238        *  of construction is returned.
    00239       */
    00240       locale
    00241       getloc() const
    00242       { return _M_buf_locale; }
    00243
    00244       // [27.5.2.2.2] buffer management and positioning
    00245       //@{
    00246       /**
    00247        *  @brief  Entry points for derived buffer functions.
    00248        *
    00249        *  The public versions of @c pubfoo dispatch to the protected
    00250        *  derived @c foo member functions, passing the arguments (if any)
    00251        *  and returning the result unchanged.
    00252       */
    00253       __streambuf_type*
    00254       pubsetbuf(char_type* __s, streamsize __n)
    00255       { return this->setbuf(__s, __n); }
    00256
    00257       pos_type
    00258       pubseekoff(off_type __off, ios_base::seekdir __way,
    00259          ios_base::openmode __mode = ios_base::in | ios_base::out)
    00260       { return this->seekoff(__off, __way, __mode); }
    00261
    00262       pos_type
    00263       pubseekpos(pos_type __sp,
    00264          ios_base::openmode __mode = ios_base::in | ios_base::out)
    00265       { return this->seekpos(__sp, __mode); }
    00266
    00267       int
    00268       pubsync() { return this->sync(); }
    00269       //@}
    00270
    00271       // [27.5.2.2.3] get area
    00272       /**
    00273        *  @brief  Looking ahead into the stream.
    00274        *  @return  The number of characters available.
    00275        *
    00276        *  If a read position is available, returns the number of characters
    00277        *  available for reading before the buffer must be refilled.
    00278        *  Otherwise returns the derived @c showmanyc().
    00279       */
    00280       streamsize
    00281       in_avail()
    00282       {
    00283     const streamsize __ret = this->egptr() - this->gptr();
    00284     return __ret ? __ret : this->showmanyc();
    00285       }
    00286
    00287       /**
    00288        *  @brief  Getting the next character.
    00289        *  @return  The next character, or eof.
    00290        *
    00291        *  Calls @c sbumpc(), and if that function returns
    00292        *  @c traits::eof(), so does this function.  Otherwise, @c sgetc().
    00293       */
    00294       int_type
    00295       snextc()
    00296       {
    00297     int_type __ret = traits_type::eof();
    00298     if (__builtin_expect(!traits_type::eq_int_type(this->sbumpc(),
    00299                                __ret), true))
    00300       __ret = this->sgetc();
    00301     return __ret;
    00302       }
    00303
    00304       /**
    00305        *  @brief  Getting the next character.
    00306        *  @return  The next character, or eof.
    00307        *
    00308        *  If the input read position is available, returns that character
    00309        *  and increments the read pointer, otherwise calls and returns
    00310        *  @c uflow().
    00311       */
    00312       int_type
    00313       sbumpc()
    00314       {
    00315     int_type __ret;
    00316     if (__builtin_expect(this->gptr() < this->egptr(), true))
    00317       {
    00318         __ret = traits_type::to_int_type(*this->gptr());
    00319         this->gbump(1);
    00320       }
    00321     else
    00322       __ret = this->uflow();
    00323     return __ret;
    00324       }
    00325
    00326       /**
    00327        *  @brief  Getting the next character.
    00328        *  @return  The next character, or eof.
    00329        *
    00330        *  If the input read position is available, returns that character,
    00331        *  otherwise calls and returns @c underflow().  Does not move the
    00332        *  read position after fetching the character.
    00333       */
    00334       int_type
    00335       sgetc()
    00336       {
    00337     int_type __ret;
    00338     if (__builtin_expect(this->gptr() < this->egptr(), true))
    00339       __ret = traits_type::to_int_type(*this->gptr());
    00340     else
    00341       __ret = this->underflow();
    00342     return __ret;
    00343       }
    00344
    00345       /**
    00346        *  @brief  Entry point for xsgetn.
    00347        *  @param  s  A buffer area.
    00348        *  @param  n  A count.
    00349        *
    00350        *  Returns xsgetn(s,n).  The effect is to fill @a s[0] through
    00351        *  @a s[n-1] with characters from the input sequence, if possible.
    00352       */
    00353       streamsize
    00354       sgetn(char_type* __s, streamsize __n)
    00355       { return this->xsgetn(__s, __n); }
    00356
    00357       // [27.5.2.2.4] putback
    00358       /**
    00359        *  @brief  Pushing characters back into the input stream.
    00360        *  @param  c  The character to push back.
    00361        *  @return  The previous character, if possible.
    00362        *
    00363        *  Similar to sungetc(), but @a c is pushed onto the stream instead
    00364        *  of "the previous character".  If successful, the next character
    00365        *  fetched from the input stream will be @a c.
    00366       */
    00367       int_type
    00368       sputbackc(char_type __c)
    00369       {
    00370     int_type __ret;
    00371     const bool __testpos = this->eback() < this->gptr();
    00372     if (__builtin_expect(!__testpos ||
    00373                  !traits_type::eq(__c, this->gptr()[-1]), false))
    00374       __ret = this->pbackfail(traits_type::to_int_type(__c));
    00375     else
    00376       {
    00377         this->gbump(-1);
    00378         __ret = traits_type::to_int_type(*this->gptr());
    00379       }
    00380     return __ret;
    00381       }
    00382
    00383       /**
    00384        *  @brief  Moving backwards in the input stream.
    00385        *  @return  The previous character, if possible.
    00386        *
    00387        *  If a putback position is available, this function decrements the
    00388        *  input pointer and returns that character.  Otherwise, calls and
    00389        *  returns pbackfail().  The effect is to "unget" the last character
    00390        *  "gotten".
    00391       */
    00392       int_type
    00393       sungetc()
    00394       {
    00395     int_type __ret;
    00396     if (__builtin_expect(this->eback() < this->gptr(), true))
    00397       {
    00398         this->gbump(-1);
    00399         __ret = traits_type::to_int_type(*this->gptr());
    00400       }
    00401     else
    00402       __ret = this->pbackfail();
    00403     return __ret;
    00404       }
    00405
    00406       // [27.5.2.2.5] put area
    00407       /**
    00408        *  @brief  Entry point for all single-character output functions.
    00409        *  @param  c  A character to output.
    00410        *  @return  @a c, if possible.
    00411        *
    00412        *  One of two public output functions.
    00413        *
    00414        *  If a write position is available for the output sequence (i.e.,
    00415        *  the buffer is not full), stores @a c in that position, increments
    00416        *  the position, and returns @c traits::to_int_type(c).  If a write
    00417        *  position is not available, returns @c overflow(c).
    00418       */
    00419       int_type
    00420       sputc(char_type __c)
    00421       {
    00422     int_type __ret;
    00423     if (__builtin_expect(this->pptr() < this->epptr(), true))
    00424       {
    00425         *this->pptr() = __c;
    00426         this->pbump(1);
    00427         __ret = traits_type::to_int_type(__c);
    00428       }
    00429     else
    00430       __ret = this->overflow(traits_type::to_int_type(__c));
    00431     return __ret;
    00432       }
    00433
    00434       /**
    00435        *  @brief  Entry point for all single-character output functions.
    00436        *  @param  s  A buffer read area.
    00437        *  @param  n  A count.
    00438        *
    00439        *  One of two public output functions.
    00440        *
    00441        *
    00442        *  Returns xsputn(s,n).  The effect is to write @a s[0] through
    00443        *  @a s[n-1] to the output sequence, if possible.
    00444       */
    00445       streamsize
    00446       sputn(const char_type* __s, streamsize __n)
    00447       { return this->xsputn(__s, __n); }
    00448
    00449     protected:
    00450       /**
    00451        *  @brief  Base constructor.
    00452        *
    00453        *  Only called from derived constructors, and sets up all the
    00454        *  buffer data to zero, including the pointers described in the
    00455        *  basic_streambuf class description.  Note that, as a result,
    00456        *  - the class starts with no read nor write positions available,
    00457        *  - this is not an error
    00458       */
    00459       basic_streambuf()
    00460       : _M_in_beg(0), _M_in_cur(0), _M_in_end(0),
    00461       _M_out_beg(0), _M_out_cur(0), _M_out_end(0),
    00462       _M_buf_locale(locale())
    00463       { }
    00464
    00465       // [27.5.2.3.1] get area access
    00466       //@{
    00467       /**
    00468        *  @brief  Access to the get area.
    00469        *
    00470        *  These functions are only available to other protected functions,
    00471        *  including derived classes.
    00472        *
    00473        *  - eback() returns the beginning pointer for the input sequence
    00474        *  - gptr() returns the next pointer for the input sequence
    00475        *  - egptr() returns the end pointer for the input sequence
    00476       */
    00477       char_type*
    00478       eback() const { return _M_in_beg; }
    00479
    00480       char_type*
    00481       gptr()  const { return _M_in_cur;  }
    00482
    00483       char_type*
    00484       egptr() const { return _M_in_end; }
    00485       //@}
    00486
    00487       /**
    00488        *  @brief  Moving the read position.
    00489        *  @param  n  The delta by which to move.
    00490        *
    00491        *  This just advances the read position without returning any data.
    00492       */
    00493       void
    00494       gbump(int __n) { _M_in_cur += __n; }
    00495
    00496       /**
    00497        *  @brief  Setting the three read area pointers.
    00498        *  @param  gbeg  A pointer.
    00499        *  @param  gnext  A pointer.
    00500        *  @param  gend  A pointer.
    00501        *  @post  @a gbeg == @c eback(), @a gnext == @c gptr(), and
    00502        *         @a gend == @c egptr()
    00503       */
    00504       void
    00505       setg(char_type* __gbeg, char_type* __gnext, char_type* __gend)
    00506       {
    00507     _M_in_beg = __gbeg;
    00508     _M_in_cur = __gnext;
    00509     _M_in_end = __gend;
    00510       }
    00511
    00512       // [27.5.2.3.2] put area access
    00513       //@{
    00514       /**
    00515        *  @brief  Access to the put area.
    00516        *
    00517        *  These functions are only available to other protected functions,
    00518        *  including derived classes.
    00519        *
    00520        *  - pbase() returns the beginning pointer for the output sequence
    00521        *  - pptr() returns the next pointer for the output sequence
    00522        *  - epptr() returns the end pointer for the output sequence
    00523       */
    00524       char_type*
    00525       pbase() const { return _M_out_beg; }
    00526
    00527       char_type*
    00528       pptr() const { return _M_out_cur; }
    00529
    00530       char_type*
    00531       epptr() const { return _M_out_end; }
    00532       //@}
    00533
    00534       /**
    00535        *  @brief  Moving the write position.
    00536        *  @param  n  The delta by which to move.
    00537        *
    00538        *  This just advances the write position without returning any data.
    00539       */
    00540       void
    00541       pbump(int __n) { _M_out_cur += __n; }
    00542
    00543       /**
    00544        *  @brief  Setting the three write area pointers.
    00545        *  @param  pbeg  A pointer.
    00546        *  @param  pend  A pointer.
    00547        *  @post  @a pbeg == @c pbase(), @a pbeg == @c pptr(), and
    00548        *         @a pend == @c epptr()
    00549       */
    00550       void
    00551       setp(char_type* __pbeg, char_type* __pend)
    00552       {
    00553     _M_out_beg = _M_out_cur = __pbeg;
    00554     _M_out_end = __pend;
    00555       }
    00556
    00557       // [27.5.2.4] virtual functions
    00558       // [27.5.2.4.1] locales
    00559       /**
    00560        *  @brief  Changes translations.
    00561        *  @param  loc  A new locale.
    00562        *
    00563        *  Translations done during I/O which depend on the current locale
    00564        *  are changed by this call.  The standard adds, "Between invocations
    00565        *  of this function a class derived from streambuf can safely cache
    00566        *  results of calls to locale functions and to members of facets
    00567        *  so obtained."
    00568        *
    00569        *  @note  Base class version does nothing.
    00570       */
    00571       virtual void
    00572       imbue(const locale&)
    00573       { }
    00574
    00575       // [27.5.2.4.2] buffer management and positioning
    00576       /**
    00577        *  @brief  Maniuplates the buffer.
    00578        *
    00579        *  Each derived class provides its own appropriate behavior.  See
    00580        *  the next-to-last paragraph of
    00581        *  http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#2 for
    00582        *  more on this function.
    00583        *
    00584        *  @note  Base class version does nothing, returns @c this.
    00585       */
    00586       virtual basic_streambuf<char_type,_Traits>*
    00587       setbuf(char_type*, streamsize)
    00588       { return this; }
    00589
    00590       /**
    00591        *  @brief  Alters the stream positions.
    00592        *
    00593        *  Each derived class provides its own appropriate behavior.
    00594        *  @note  Base class version does nothing, returns a @c pos_type
    00595        *         that represents an invalid stream position.
    00596       */
    00597       virtual pos_type
    00598       seekoff(off_type, ios_base::seekdir,
    00599           ios_base::openmode /*__mode*/ = ios_base::in | ios_base::out)
    00600       { return pos_type(off_type(-1)); }
    00601
    00602       /**
    00603        *  @brief  Alters the stream positions.
    00604        *
    00605        *  Each derived class provides its own appropriate behavior.
    00606        *  @note  Base class version does nothing, returns a @c pos_type
    00607        *         that represents an invalid stream position.
    00608       */
    00609       virtual pos_type
    00610       seekpos(pos_type,
    00611           ios_base::openmode /*__mode*/ = ios_base::in | ios_base::out)
    00612       { return pos_type(off_type(-1)); }
    00613
    00614       /**
    00615        *  @brief  Synchronizes the buffer arrays with the controlled sequences.
    00616        *  @return  -1 on failure.
    00617        *
    00618        *  Each derived class provides its own appropriate behavior,
    00619        *  including the definition of "failure".
    00620        *  @note  Base class version does nothing, returns zero.
    00621       */
    00622       virtual int
    00623       sync() { return 0; }
    00624
    00625       // [27.5.2.4.3] get area
    00626       /**
    00627        *  @brief  Investigating the data available.
    00628        *  @return  An estimate of the number of characters available in the
    00629        *           input sequence, or -1.
    00630        *
    00631        *  "If it returns a positive value, then successive calls to
    00632        *  @c underflow() will not return @c traits::eof() until at least that
    00633        *  number of characters have been supplied.  If @c showmanyc()
    00634        *  returns -1, then calls to @c underflow() or @c uflow() will fail."
    00635        *  [27.5.2.4.3]/1
    00636        *
    00637        *  @note  Base class version does nothing, returns zero.
    00638        *  @note  The standard adds that "the intention is not only that the
    00639        *         calls [to underflow or uflow] will not return @c eof() but
    00640        *         that they will return "immediately".
    00641        *  @note  The standard adds that "the morphemes of @c showmanyc are
    00642        *         "es-how-many-see", not "show-manic".
    00643       */
    00644       virtual streamsize
    00645       showmanyc() { return 0; }
    00646
    00647       /**
    00648        *  @brief  Multiple character extraction.
    00649        *  @param  s  A buffer area.
    00650        *  @param  n  Maximum number of characters to assign.
    00651        *  @return  The number of characters assigned.
    00652        *
    00653        *  Fills @a s[0] through @a s[n-1] with characters from the input
    00654        *  sequence, as if by @c sbumpc().  Stops when either @a n characters
    00655        *  have been copied, or when @c traits::eof() would be copied.
    00656        *
    00657        *  It is expected that derived classes provide a more efficient
    00658        *  implementation by overriding this definition.
    00659       */
    00660       virtual streamsize
    00661       xsgetn(char_type* __s, streamsize __n);
    00662
    00663       /**
    00664        *  @brief  Fetches more data from the controlled sequence.
    00665        *  @return  The first character from the <em>pending sequence</em>.
    00666        *
    00667        *  Informally, this function is called when the input buffer is
    00668        *  exhausted (or does not exist, as buffering need not actually be
    00669        *  done).  If a buffer exists, it is "refilled".  In either case, the
    00670        *  next available character is returned, or @c traits::eof() to
    00671        *  indicate a null pending sequence.
    00672        *
    00673        *  For a formal definiton of the pending sequence, see a good text
    00674        *  such as Langer & Kreft, or [27.5.2.4.3]/7-14.
    00675        *
    00676        *  A functioning input streambuf can be created by overriding only
    00677        *  this function (no buffer area will be used).  For an example, see
    00678        *  http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#6
    00679        *
    00680        *  @note  Base class version does nothing, returns eof().
    00681       */
    00682       virtual int_type
    00683       underflow()
    00684       { return traits_type::eof(); }
    00685
    00686       /**
    00687        *  @brief  Fetches more data from the controlled sequence.
    00688        *  @return  The first character from the <em>pending sequence</em>.
    00689        *
    00690        *  Informally, this function does the same thing as @c underflow(),
    00691        *  and in fact is required to call that function.  It also returns
    00692        *  the new character, like @c underflow() does.  However, this
    00693        *  function also moves the read position forward by one.
    00694       */
    00695       virtual int_type
    00696       uflow()
    00697       {
    00698     int_type __ret = traits_type::eof();
    00699     const bool __testeof = traits_type::eq_int_type(this->underflow(),
    00700                             __ret);
    00701     if (!__testeof)
    00702       {
    00703         __ret = traits_type::to_int_type(*this->gptr());
    00704         this->gbump(1);
    00705       }
    00706     return __ret;
    00707       }
    00708
    00709       // [27.5.2.4.4] putback
    00710       /**
    00711        *  @brief  Tries to back up the input sequence.
    00712        *  @param  c  The character to be inserted back into the sequence.
    00713        *  @return  eof() on failure, "some other value" on success
    00714        *  @post  The constraints of @c gptr(), @c eback(), and @c pptr()
    00715        *         are the same as for @c underflow().
    00716        *
    00717        *  @note  Base class version does nothing, returns eof().
    00718       */
    00719       virtual int_type
    00720       pbackfail(int_type /* __c */  = traits_type::eof())
    00721       { return traits_type::eof(); }
    00722
    00723       // Put area:
    00724       /**
    00725        *  @brief  Multiple character insertion.
    00726        *  @param  s  A buffer area.
    00727        *  @param  n  Maximum number of characters to write.
    00728        *  @return  The number of characters written.
    00729        *
    00730        *  Writes @a s[0] through @a s[n-1] to the output sequence, as if
    00731        *  by @c sputc().  Stops when either @a n characters have been
    00732        *  copied, or when @c sputc() would return @c traits::eof().
    00733        *
    00734        *  It is expected that derived classes provide a more efficient
    00735        *  implementation by overriding this definition.
    00736       */
    00737       virtual streamsize
    00738       xsputn(const char_type* __s, streamsize __n);
    00739
    00740       /**
    00741        *  @brief  Consumes data from the buffer; writes to the
    00742        *          controlled sequence.
    00743        *  @param  c  An additional character to consume.
    00744        *  @return  eof() to indicate failure, something else (usually
    00745        *           @a c, or not_eof())
    00746        *
    00747        *  Informally, this function is called when the output buffer is full
    00748        *  (or does not exist, as buffering need not actually be done).  If a
    00749        *  buffer exists, it is "consumed", with "some effect" on the
    00750        *  controlled sequence.  (Typically, the buffer is written out to the
    00751        *  sequence verbatim.)  In either case, the character @a c is also
    00752        *  written out, if @a c is not @c eof().
    00753        *
    00754        *  For a formal definiton of this function, see a good text
    00755        *  such as Langer & Kreft, or [27.5.2.4.5]/3-7.
    00756        *
    00757        *  A functioning output streambuf can be created by overriding only
    00758        *  this function (no buffer area will be used).
    00759        *
    00760        *  @note  Base class version does nothing, returns eof().
    00761       */
    00762       virtual int_type
    00763       overflow(int_type /* __c */ = traits_type::eof())
    00764       { return traits_type::eof(); }
    00765
    00766 #ifdef _GLIBCXX_DEPRECATED
    00767     // Annex D.6
    00768     public:
    00769       /**
    00770        *  @brief  Tosses a character.
    00771        *
    00772        *  Advances the read pointer, ignoring the character that would have
    00773        *  been read.
    00774        *
    00775        *  See http://gcc.gnu.org/ml/libstdc++/2002-05/msg00168.html
    00776        *
    00777        *  @note  This function has been deprecated by the standard.  You
    00778        *         must define @c _GLIBCXX_DEPRECATED to make this visible; see
    00779        *         c++config.h.
    00780       */
    00781       void
    00782       stossc()
    00783       {
    00784     if (this->gptr() < this->egptr())
    00785       this->gbump(1);
    00786     else
    00787       this->uflow();
    00788       }
    00789 #endif
    00790
    00791     private:
    00792       // _GLIBCXX_RESOLVE_LIB_DEFECTS
    00793       // Side effect of DR 50.
    00794       basic_streambuf(const __streambuf_type& __sb)
    00795       : _M_in_beg(__sb._M_in_beg), _M_in_cur(__sb._M_in_cur),
    00796       _M_in_end(__sb._M_in_end), _M_out_beg(__sb._M_out_beg),
    00797       _M_out_cur(__sb._M_out_cur), _M_out_end(__sb._M_out_cur),
    00798       _M_buf_locale(__sb._M_buf_locale)
    00799       { }
    00800
    00801       __streambuf_type&
    00802       operator=(const __streambuf_type&) { return *this; };
    00803     };
    00804
    00805   // Explicit specialization declarations, defined in src/streambuf.cc.
    00806   template<>
    00807     streamsize
    00808     __copy_streambufs_eof(basic_streambuf<char>* __sbin,
    00809               basic_streambuf<char>* __sbout, bool& __ineof);
    00810 #ifdef _GLIBCXX_USE_WCHAR_T
    00811   template<>
    00812     streamsize
    00813     __copy_streambufs_eof(basic_streambuf<wchar_t>* __sbin,
    00814               basic_streambuf<wchar_t>* __sbout, bool& __ineof);
    00815 #endif
    00816
    00817 _GLIBCXX_END_NAMESPACE
    00818
    00819 #ifndef _GLIBCXX_EXPORT_TEMPLATE
    00820 # include <bits/streambuf.tcc>
    00821 #endif
    00822
    00823 #endif /* _GLIBCXX_STREAMBUF */